(******************************************************************************

______________________________________________________________________________

PkYubikey                                                 (C) 2009, 2010 Pepak
http://www.pepak.net/bezpecnost/pkyubikey/                http://www.pepak.net
______________________________________________________________________________


Copyright (c) 2010, Pepak (http://www.pepak.net)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of Pepak nor the
      names of his contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL PEPAK BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

******************************************************************************)

unit uAnsiStrings;
{$DEFINE ASSEMBLER}
{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

interface

function LowCase(ch: AnsiChar): AnsiChar;
{$IFDEF MINIMIZESIZE}
function StrScan(const Str: PAnsiChar; Chr: AnsiChar): PAnsiChar;
function StrLen(const Str: PAnsiChar): Cardinal;
function StrEnd(const Str: PAnsiChar): PAnsiChar;
function StrCat(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar;
function StrLCat(Dest: PAnsiChar; const Source: PAnsiChar; MaxLen: Cardinal): PAnsiChar;
function StrCopy(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar;
function StrECopy(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar;
function StrLCopy(Dest: PAnsiChar; const Source: PAnsiChar; MaxLen: Cardinal): PAnsiChar;
function StrAlloc(Size: Cardinal): PAnsiChar;
procedure StrDispose(Str: PAnsiChar);
{$ENDIF}

implementation

{$IFDEF FPC}
  {$UNDEF ASSEMBLER}
{$ENDIF}

{$IFDEF ASSEMBLER}
function LowCase(ch: AnsiChar): AnsiChar; assembler;
asm
{ ->    AL      Character       }
{ <-    AL      Result          }

        CMP     AL,'A'
        JB      @@exit
        CMP     AL,'Z'
        JA      @@exit
        ADD     AL,'a' - 'A'
@@exit:
end;
{$ELSE}
function LowCase(ch: AnsiChar): AnsiChar;
begin
  if (ch >= 'A') and (ch <= 'Z') then
    Result := AnsiChar(Byte(ch) + Byte('a') - Byte('A'))
  else
    Result := ch;
end;
{$ENDIF}

{$IFDEF MINIMIZESIZE}

{$IFDEF ASSEMBLER}
function StrScan(const Str: PAnsiChar; Chr: AnsiChar): PAnsiChar; assembler;
asm
        PUSH    EDI
        PUSH    EAX
        MOV     EDI,Str
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        POP     EDI
        MOV     AL,Chr
        REPNE   SCASB
        MOV     EAX,0
        JNE     @@1
        MOV     EAX,EDI
        DEC     EAX
@@1:    POP     EDI
end;
{$ELSE}
function StrScan(const Str: PAnsiChar; Chr: AnsiChar): PAnsiChar;
begin
  Result := Str;
  while (Result^ <> #0) and (Result^ <> Chr) do
    Inc(Result);
  if (Result^ = #0) then
    Result := nil;
end;
{$ENDIF}

{$IFDEF ASSEMBLER}
function StrLen(const Str: PAnsiChar): Cardinal; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        MOV     EAX,0FFFFFFFEH
        SUB     EAX,ECX
        MOV     EDI,EDX
end;
{$ELSE}
function StrLen(const Str: PAnsiChar): Cardinal;
var P: PAnsiChar;
begin
  Result := 0;
  P := Str;
  while P^ <> #0 do
    begin
    Inc(p);
    Inc(Result);
    end;
end;
{$ENDIF}

{$IFDEF ASSEMBLER}
function StrEnd(const Str: PAnsiChar): PAnsiChar; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        LEA     EAX,[EDI-1]
        MOV     EDI,EDX
end;
{$ELSE}
function StrEnd(const Str: PAnsiChar): PAnsiChar;
begin
  Result := Str;
  while Result^ <> #0 do
    Inc(Result);
end;
{$ENDIF}

function StrCat(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar;
begin
  StrCopy(StrEnd(Dest), Source);
  Result := Dest;
end;

{$IFDEF ASSEMBLER}
function StrLCat(Dest: PAnsiChar; const Source: PAnsiChar; MaxLen: Cardinal): PAnsiChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX
        MOV     EDI,Dest
        MOV     ESI,Source
        MOV     EBX,MaxLen
        CALL    StrEnd
        MOV     ECX,EDI
        ADD     ECX,EBX
        SUB     ECX,EAX
        JBE     @@1
        MOV     EDX,ESI
        CALL    StrLCopy
@@1:    MOV     EAX,EDI
        POP     EBX
        POP     ESI
        POP     EDI
end;
{$ELSE}
function StrLCat(Dest: PAnsiChar; const Source: PAnsiChar; MaxLen: Cardinal): PAnsiChar;
begin
  MaxLen := MaxLen - StrLen(Source);
  Result := StrEnd(Dest);
  if MaxLen > 0 then
    StrLCopy(Result, Source, MaxLen);
  Result := Dest;
end;
{$ENDIF}

{$IFDEF ASSEMBLER}
function StrLCopy(Dest: PAnsiChar; const Source: PAnsiChar; MaxLen: Cardinal): PAnsiChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     EBX,ECX
        XOR     AL,AL
        TEST    ECX,ECX
        JZ      @@1
        REPNE   SCASB
        JNE     @@1
        INC     ECX
@@1:    SUB     EBX,ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,EDI
        MOV     ECX,EBX
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EBX
        AND     ECX,3
        REP     MOVSB
        STOSB
        MOV     EAX,EDX
        POP     EBX
        POP     ESI
        POP     EDI
end;
{$ELSE}
function StrLCopy(Dest: PAnsiChar; const Source: PAnsiChar; MaxLen: Cardinal): PAnsiChar;
var Src: PAnsiChar;
begin
  Result := Dest;
  Src := Source;
  while (MaxLen > 0) and (Src^ <> #0) do
    begin
    Result^ := Src^;
    Inc(Result);
    Inc(Src);
    Dec(MaxLen);
    end;
  Result := Dest;
end;
{$ENDIF}

{$IFDEF ASSEMBLER}
function StrCopy(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,ECX
        MOV     EAX,EDI
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EDX
        AND     ECX,3
        REP     MOVSB
        POP     ESI
        POP     EDI
end;
{$ELSE}
function StrCopy(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar;
var Src: PAnsiChar;
begin
  Result := Dest;
  Src := Source;
  while (Src^ <> #0) do
    begin
    Result^ := Src^;
    Inc(Result);
    Inc(Src);
    end;
  Result := Dest;
end;
{$ENDIF}

{$IFDEF ASSEMBLER}
function StrECopy(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,ECX
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EDX
        AND     ECX,3
        REP     MOVSB
        LEA     EAX,[EDI-1]
        POP     ESI
        POP     EDI
end;
{$ELSE}
function StrECopy(Dest: PAnsiChar; const Source: PAnsiChar): PAnsiChar;
begin
  Result := StrEnd(StrCopy(Dest, Source));
end;
{$ENDIF}

function StrAlloc(Size: Cardinal): PAnsiChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

procedure StrDispose(Str: PAnsiChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;
{$ENDIF}

end.

